package eu.univento.maya.game;

/**
 * enum for gamestages
 * @author joethei
 * @version 1.0
 */
public enum GameStage {
    /**
     * players are waiting in the lobby until min player count is reached
     */
    Lobby(1),
    /**
     * players waiting while map is being loaded
     */
    Warmup(2),
    /**
     * game has been started, teams are hiding there block
     */
    InGame(3),
    /**
     * players can buy items
     */
    Buy(4),
    /**
     * players can fight
     */
    DeathMatch(5),
    /**
     * server is reseting map and restarts
     */
    Restart(6);

    /**
     * id of stage
     */
    private int id;
    /**
     * gets gamestage for id
     * @param id Integer
     */
    private GameStage(int id) {
        this.setId(id);
    }
    /**
     * gets id of gamestage
     * @return Integer
     */
    public int getId() {
        return id;
    }
    /**
     * sets id
     * @param id Integer
     */
    public void setId(int id) {
        this.id = id;
    }
}